
/*
	File: atest.cpp
	(c) Oscar Nierstrasz 30.3.96
	Test Array class.
*/

#include <iostream.h>
#include <exception.h>

#include "Array.h"
#include "atest.h"
#include "String.h"

void atest(Array<int>);
void mytest(Array<int>);
void rtest(Array<int>);

int main(void)
{
	try {
		cout << "test int array a" << endl;
		Array<int> a(4);
		int i;
		for (i=0;i<a.size();i++)  {
			a[i] = i*i;
		}
		printArray(cout, "a", a);
		
		mytest(a);
		// atest(a);
		// rtest(a);
	}
	catch (xmsg &err) {
		cout << "Exception: " << err.what() << endl;  // err.why()
	}

	cout << endl << "END OF TESTS" << endl;	
	return 0;
}

void
mytest(Array<int> a)
{
	MyArray<int> mine(a);
	cout << "Testing template inheritance" << endl;
	
	mine.print();
}

void
atest(Array<int> a)
{
	int i;
	cout << "test char array c" << endl;
	Array<char> c(5);
	for (i=0;i<c.size();i++)  {
		c[i] = 'a' + i;
	}
	printArray(cout, "c", c);

	cout << "test copy constructor b(a)" << endl;
	Array<int> b(a);
	printArray(cout, "b", b);

	cout << "test assignment d=a" << endl;
	Array<int> d;
	d = a;
	printArray(cout, "d", d);
	
	cout << "test array init e" << endl;
	int primes[5] = { 2, 3, 5, 7, 11 };
	Array<int> e(5,primes);
	printArray(cout, "e", e);
	
	cout << "test string array" << endl;
	Array<String> sa(2);
	sa[0] = "hello";
	cout << "Enter your name:";
	sa[1].getline(cin);
	printArray(cout, "sa", sa);
}

void
rtest(Array<int> a)
{
	int i;
	cout << "test resize to 10" << endl;
	a.resize(10);
	for (i=0;i<a.size();i++)  {
		a[i] = i*i;
	}
	printArray(cout, "a", a);

	cout << "test resize to 8" << endl;
	a.resize(8);
	printArray(cout, "a", a);	

	cout << "test resize to 3" << endl;
	a.resize(3);
	printArray(cout, "a", a);	
	
	cout << "Enter new size:";
	int newSize;
	cin >> newSize;				// NB: can interfere with String::getline
	cout << "test resize to " << newSize << endl;
	a.resize(newSize);
	for (i=0;i<a.size();i++)  {
		a[i] = i*i;
	}
	printArray(cout, "a", a);
}

