
/*
	File: atest.h
	(c) Oscar Nierstrasz 30.3.96
	Test Array class.
*/

#ifndef ATEST_H
#define ATEST_H

#include "Array.h"

template <class Item>
void
printArray(ostream& os, char * name, Array<Item>& a)
{
	for (int i=0; i<a.size(); i++)  {
		os << name << "[" << i << "] = " << a[i] << endl;
	}
};

template <class Item>
class MyArray : public Array<Item>
{
  public:
	MyArray (const Array<Item>& copy) : Array<Item>(copy) { };
	// are the default constructors etc. ok?

	void print (void);
};

template <class Item>
void
MyArray<Item>::print (void)
{
	cout << "<" << this->size() << "> { ";
	for (int i=0; i<this->size(); i++)  {
		cout << (*this)[i] << " ";
	}
	cout << "} " << endl;
};

#endif // ATEST_H