
#include <iostream.h>

// Incredibly, there is no <exception.h> for g++!
// There is a <std/exception.h>, but it does not define xmsg.
// Luckily the Sun CC exception.h works fine ...

#ifdef __GNUC__
#include <std/exception.h>
#include "/opt/SUNWspro/SC3.0.1/include/CC/exception.h"
#else
#include <exception.h>
#endif

void nxtest(void);
void nxthrow(void);
void xtest(void);
void xtestNocatch(void);
void xtestThrow(void);
void sxtest(void);
void sxthrow(void);

int main(void)
{
	nxtest();
	sxtest();
	xtest();
	return 0;
}

void nxtest(void)
{
	int ok = 0;
	try {
		nxthrow();
	}
	catch (int err) {
		cout << "Exception: " << err << endl;
		ok = 1;
	}
	if (ok)
		cout << "nxtest succeeded" << endl;
	else	cout << "nxtest failed" << endl;
}

void nxthrow(void)
{
	throw(67);
}

void sxtest(void)
{
	int ok = 0;
	try {
		sxthrow();
	}
	catch (char *err) {
		cout << "Exception: " << err << endl;
		ok = 1;
	}
	if (ok)
		cout << "sxtest succeeded" << endl;
	else	cout << "sxtest failed" << endl;
}

void sxthrow(void)
{
	throw("I'm just a string");
}

// test whether an exception raised in a nested function call
// is propogated up the call chain
// This test works with MPW C++
void xtest(void)
{
	int ok = 0;
	try {
		xtestNocatch();
	}
	catch (xmsg & err) {
	// catch (char * err) {
		cout << "Exception: " << err.why() << endl;
		// cout << "Exception: " << err << endl;
	}
	if (ok)
		cout << "xtest succeeded" << endl;
	else	cout << "xtest failed" << endl;
}

// call a function that raises an exception, without catching it
void xtestNocatch(void)
{
	xtestThrow();
}

// NB: with MPW, xmsg("reason") sets _What rather than _Why
void xtestThrow(void)
{
	throw(xmsg("I'm exceptional!"));
	// throw("I'm exceptional!");
}

