
/*
	File: Gomoku.h
	Author: Oscar Nierstrasz 29.2.96
	
	Go-moku interface
	Board is 19x19
	
	Invariants:
	- initially winner is nobody
	- game is over when all squares are occupied,
	  or there is a winner
	- winner is X or O iff winner has five in a row
	- turn is X or O
	- initially it is the turn of X
	- X and O swap turns (turn never equals previous turn)
	- a player can't mark a square that is already marked
*/


#ifndef GOMOKU_H
#define GOMOKU_H

#include "BoardGame.h"

class Gomoku : public BoardGame {
  public :
	// constructor with default arguments:
	Gomoku (int r=19, int c=19, int ws=5)
		throw(xmsg);
	
	// virtual destructor:
	virtual ~Gomoku (void);
	
	// don't need copy constructor or assignment???

  protected :
	const int winningScore;
	virtual void checkWinner (int row, int col);
	void checkScore (int row, int col,
		void (*thisMove) (int&,int&),
		void (*thatMove) (int&, int&));
		// void (*) (int&,int&),
		// void (*) (int&, int&));
}
;

#endif // GOMOKU_H
