
/*
	File: Debug.h
	(c) Oscar Nierstrasz 30.3.96
	
	Implementation of Debug operations.
	#define DEBUG to turn on debug printing
*/

#include "Debug.h"

// Print "DEBUG> " at the beginning of a line
// (i.e., if "endl" has just been printed)
void
Debug::printLeader (void)
{
	if (needLeader)  {
		cerr << "DEBUG> ";
		needLeader = 0;
	}
}

// If the current item to print is the global endl function,
// then remember that we need to print the "DEBUG>" leader.
Debug&
Debug::endl (ostream&(*op) (ostream&))
{
	if (op == ::endl)  {		
		needLeader = 1;
	}
	cerr << op;
	return *this;
}

Debug debug; // global instance
