
/*
	bfib.C -- a lazy Fibonacci function for BigNats
*/

#include <iostream.h>
#include <stdlib.h>	// for atoi()

#include "Bignat.h"
#include "lazy.h"

#include <new.h>

// #define DEBUG

// int bfib(int);

Bignat computeFib(int n, LazyList<Bignat>& fibList);
LazyList<Bignat> bfib(computeFib);

void listfibs(void);

void exitOnNoMem (void);

int main(int argc, char* argv[])
{
	set_new_handler(exitOnNoMem);

	if (argc <= 1) {
		cout << "no args" << endl;
		listfibs();
	} else {
		int i;
		for (i=1; i<argc; i++) {
			// cout << "argc[" << i << "] = " << argv[i] << endl;
			cout << "bfib(" << argv[i] << ") = "
				<< bfib(atoi(argv[i])) << endl;
		}
	}
	return 0;
}

void exitOnNoMem (void)
{
	cout << "OOPS -- out of memory!" << endl;
	exit(1);
}

Bignat
computeFib(int n, LazyList<Bignat>& fibList)
{
	Bignat result;
#ifdef DEBUG
	cerr << "computing fib(" << n << ") = " << flush;
#endif
	switch (n) {
	case 0 :
	case 1 :
#ifdef DEBUG
	cerr << 1 << endl;
#endif
		// return Bignat(1);
		return 1;
		break;
	default :
		result = fibList(n-1) + fibList(n-2);
#ifdef DEBUG
	cerr << result << endl;
#endif
		return result;
		break;
	}
}

void listfibs(void)
{
	int i;
	for (i=0;;i++) {
		cout << "bfib(" << i << ") = " << bfib(i) << endl;
	}
}

