
// dstack.h
// Author: Oscar Nierstrasz 30.11.95
// An absolutely minimal stack interface using linked lists.

#ifndef DSTACK_H
#define DSTACK_H

#include <exception.h>

typedef char* Item; // Redefine as necessary (alternative to templates)

class DStack
{	

public:
	DStack(void);
	~DStack(void);

	// inline functions:
	int count(void) { return size; };
	int empty(void) { return size == 0; };

	// NB: pop() does not return a value
	// use top() before pop() to retrieve the value

	void push(Item item);
	Item top(void) throw(xmsg);
	void pop(void) throw(xmsg);

private:
	// The stack is implemented by a number of cells
	// that are linked together, and hold the actual values.
	// The Cell interface is only visible within DStack.
	class Cell
	{
	public:
		Item value;
		Cell *next;
	};

	Cell *topCell;
	int size;

};

#endif

