/*
	RevCommand is a FileArgsCommand that reverses the lines
	of its InputStream arguments.
*/

import java.io.*; // for DataInputStream etc.
import java.util.*; // for Stack, EmptyStackException

public class RevCommand extends FileArgsCommand {

	public RevCommand(String args[]) {
		super(args);
	}

	protected void command(InputStream in) {
		try {
			DataInput ds = new DataInputStream(in); // enable readLine()
			String s;
			Stack stack = new Stack();
			while ((s = ds.readLine()) != null) {
				stack.push(s);
			}
			while (!stack.empty()) {
				System.out.println((String) stack.pop());
			}
		} catch (EmptyStackException err) { // never happens!
		} catch (IOException err) { } // should never happen ...
		System.out.flush();
	}

}
