
/*
	From C++ FAQs
	FAQ # 140: "What is the hiding rule?"

g++ badHiding.C -o badHiding
badHiding.C: In function `int main()':
badHiding.C:39: warning: `float' used for argument 1 of `Derived::g(int)'

CC badHiding.C -o badHiding
"badHiding.C", line 24: Warning: Derived::g hides the virtual function Base::g(float).
1 Warning(s) detected.
*/

#include <iostream.h>

class Base
{
public:
	// virtual ~Base(void) {}
	virtual void f(float x) { cout << "Base::f(float)" << endl; }
	virtual void g(float x) { cout << "Base::g(float)" << endl; }
		void h(float x) { cout << "Base::h(float)" << endl; }
};

class Derived : public Base
{
public:
	virtual void f(float x) { cout << "Derived::f(float)" << endl; }
	virtual void g(int x) { cout << "Derived::g(int)" << endl; }
		void h(float x) { cout << "Derived::h(float)" << endl; }
};

int
main(void)
{
	Derived d;
	Base* bp = &d;
	Derived* dp = &d;

	// Good: behaviour depends solely on type of the object:
	bp->f(3.14f); // Calls Derived::f(float)
	dp->f(3.14f); // Calls Derived::f(float)

	// Bad: behaviour depends on type of the pointer:
	bp->g(3.14f); // Calls Base::g(float)
	dp->g(3.14f); // Calls Derived::g(int) -- surprise!

	// Bad: behaviour depends on type of the pointer:
	bp->h(3.14f); // Calls Base::h(float) -- surprise!
	dp->h(3.14f); // Calls Derived::h(float)

	return 0;
}

/*
	Output:
	Derived::f(float)
	Derived::f(float)
	Base::g(float)
	Derived::g(int)
	Base::h(float)
	Derived::h(float)
*/
